--CORPS METHODES

--27, 33, 35
CREATE OR REPLACE TYPE BODY client_type AS 
  MEMBER FUNCTION nbCepargne RETURN NUMBER IS
  nb_compte NUMBER;
  BEGIN
    SELECT COUNT(*) INTO nb_compte 
	FROM CptCourant cep
	WHERE cep.ref_Client.num = SELF.num;
    RETURN nb_compte;
  END nbCepargne;
--
  MEMBER PROCEDURE supprimeTel(indice In NUMBER) IS
    liste_tel telephone_vry_type;
  BEGIN
	SELECT telephone_vry INTO liste_tel 
		FROM Client WHERE num = SELF.num FOR UPDATE;
	IF (liste_tel(indice).numTel IS NULL) THEN 
	  DBMS_OUTPUT.PUT_LINE('Pas de tlphone rpertori l''indice ' || indice);
	ELSE	
	  liste_tel(indice) := telephone_elt_vry_type(NULL);
	  DBMS_OUTPUT.PUT_LINE('Tlphone ( ' || indice || ' ) supprim');
	END IF;
	UPDATE Client 
		SET telephone_vry = liste_tel 
		WHERE num = SELF.num;
  END supprimeTel;
--  
 MEMBER PROCEDURE afficheInterets IS
    epargneTotale NUMBER := 0;
    CURSOR LesCptEpargnes IS SELECT VALUE(cep) 
	FROM CptEpargne cep WHERE cep.ref_Client.num = SELF.num;
    unCptEpargne CptEpargne_type;
  BEGIN
    OPEN LesCptEpargnes;
    FETCH LesCptEpargnes INTO unCptEpargne;
    WHILE (LesCptEpargnes%FOUND) LOOP
	epargneTotale := epargneTotale + unCptEpargne.calculeInterets(); 
	DBMS_OUTPUT.PUT_LINE('Cumul du compte : ' || unCptEpargne.nCompte || ' intrts : ' || unCptEpargne.calculeInterets());
        FETCH LesCptEpargnes INTO unCptEpargne;
    END LOOP;
    CLOSE LesCptEpargnes;
    DBMS_OUTPUT.PUT_LINE('L''pargne totale est de  : ' || epargneTotale || ' ');
  END afficheInterets;
END;
/
show err


--36
CREATE OR REPLACE TYPE BODY compte_type AS
--
 STATIC PROCEDURE fermeCompte (cpt IN VARCHAR2) IS
  nbMouvement   NUMBER;
  unCompteCourant CptCourant_type;
  unCptEpargne    CptEpargne_type;
BEGIN
   BEGIN
    SELECT VALUE(cou) INTO unCompteCourant FROM cptCourant cou WHERE nCompte = cpt;
    DBMS_OUTPUT.PUT_LINE('Le solde du compte '|| cpt ||' est : ' || unCompteCourant.solde);
    SELECT COUNT(*) INTO nbMouvement FROM Mouvement m WHERE m.ref_CptCourant.nCompte = cpt;
    DELETE FROM Mouvement m WHERE m.ref_CptCourant.nCompte = cpt;
    DELETE FROM cptCourant WHERE nCompte = cpt;
    DBMS_OUTPUT.PUT_LINE('Compte courant dtruit, ' || nbMouvement || ' mouvements supprim(s)');
    COMMIT;
    EXCEPTION
	WHEN NO_DATA_FOUND THEN
	  BEGIN
	   SELECT VALUE(cep) INTO unCptEpargne FROM CptEpargne cep WHERE nCompte = cpt;
 	   DBMS_OUTPUT.PUT_LINE('Le solde du compte '|| cpt ||' est : ' || unCptEpargne.solde);
    	   DELETE FROM CptEpargne WHERE nCompte = cpt;
           DBMS_OUTPUT.PUT_LINE('Compte pargne supprim.');
           COMMIT;
  	   EXCEPTION
  	   WHEN NO_DATA_FOUND THEN
 		DBMS_OUTPUT.PUT_LINE('Le compte '|| cpt ||' n''existe pas!');
	   WHEN OTHERS THEN
	  	DBMS_OUTPUT.PUT_LINE('Gros Problme...'); 	
          END;
	WHEN OTHERS THEN
	  ROLLBACK;
	  DBMS_OUTPUT.PUT_LINE('Gros Problme...'); 
  END;    	
  END fermeCompte;
END;
/
show err

--28, 29, 31, 32, 34, 37
CREATE OR REPLACE TYPE BODY cptCourant_type AS
--
 MEMBER FUNCTION nbSignataire RETURN NUMBER Is
  nb_sign NUMBER;
  BEGIN
    SELECT COUNT(DISTINCT(ant.num)) INTO nb_sign 
	FROM TABLE (SELECT cou.signataire_nt 
		FROM cptCourant cou WHERE cou.nCompte = SELF.nCompte) ant;
    RETURN nb_sign;
  END nbSignataire;  

 MEMBER FUNCTION nbSignataire(droitparam IN CHAR) RETURN NUMBER Is
  nb_sign NUMBER;
  BEGIN
    SELECT COUNT(DISTINCT(ant.num)) INTO nb_sign 
	FROM TABLE (SELECT cou.signataire_nt 
		FROM cptCourant cou WHERE cou.nCompte = SELF.nCompte) ant
	WHERE ant.droit = droitparam;
    RETURN nb_sign;
  END nbSignataire;  
--
  MEMBER PROCEDURE supprimeSign(nclient In NUMBER) IS
    num_sign signataire_tabnt.num%TYPE;
  BEGIN
    SELECT DISTINCT(ant.num) INTO num_sign 
	FROM TABLE(SELECT signataire_nt 
		FROM cptCourant WHERE nCompte=SELF.nCompte) ant 
	WHERE ant.num = nclient;
    DELETE FROM TABLE
	(SELECT signataire_nt FROM cptCourant WHERE nCompte=SELF.nCompte) ant 
	WHERE ant.num = nclient;
    DBMS_OUTPUT.PUT_LINE('Suppression du signataire '||nclient||' effectue pour le compte ' || SELF.nCompte);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('Le signataire '|| nclient ||' n''existe pas pour le compte ' || SELF.nCompte);
  END supprimeSign;
--
  MEMBER FUNCTION estTitulaire(cli IN NUMBER) RETURN BOOLEAN IS
	resultat NUMBER := 0;
   BEGIN
	SELECT COUNT(*) INTO resultat
		FROM cptCourant cou 
		WHERE cou.ref_Client.num = cli
		AND cou.nCompte = SELF.nCompte;
	IF (resultat = 1) THEN
		RETURN TRUE;
	ELSE
		RETURN FALSE;
	END IF;
  END estTitulaire;
--
  MEMBER FUNCTION estSignataire(cli IN NUMBER, droitparam IN CHAR) RETURN BOOLEAN IS
	resultat NUMBER := 0;
   BEGIN
	SELECT COUNT(ant.num) INTO resultat
		FROM TABLE (SELECT cou.signataire_nt 
			FROM cptCourant cou WHERE cou.nCompte = SELF.nCompte) ant
	WHERE ant.droit = droitparam
	AND ant.num = cli;
	IF (resultat = 0) THEN
		RETURN FALSE; 
	ELSE
		RETURN TRUE;
	END IF;	
  END estSignataire;
--
  MEMBER PROCEDURE passeMvt (cli IN NUMBER, somme IN NUMBER) AS
        clientInconnu EXCEPTION;
	PRAGMA EXCEPTION_INIT(clientInconnu,-02290);
   BEGIN
    IF (somme < 0 AND NOT (SELF.estSignataire(cli, 'D') OR SELF.estTitulaire(cli))) THEN
	DBMS_OUTPUT.PUT_LINE('Le client '|| cli ||' n''est ni titulaire, ni signataire pour le compte ' 
			|| SELF.nCompte || ' retrait interdit.');
	ELSE
 	INSERT INTO Mouvement VALUES (mouvement_type(
		(SELECT REF(cl) FROM Client cl WHERE cl.num = cli),
		(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = SELF.NCompte),
		SYSDATE, somme)  );
	  UPDATE cptCourant 
		SET solde = solde + somme WHERE nCompte = SELF.NCompte;
	  COMMIT;
    END IF;
  EXCEPTION
	WHEN clientInconnu THEN
		DBMS_OUTPUT.PUT_LINE('Client ' || cli || ' inconnu, opration impossible.');
 	WHEN NO_DATA_FOUND THEN
 		DBMS_OUTPUT.PUT_LINE('Compte ' || SELF.nCompte || ' inconnu, opration impossible.');
  END passeMvt;
END;
/
show err

--30
CREATE OR REPLACE TYPE BODY cptEpargne_type AS
  MEMBER FUNCTION calculeInterets RETURN NUMBER IS
    SommeAvecInterets cptEpargne.solde%TYPE;
  BEGIN
    SELECT solde*(1+ txInt/100) INTO SommeAvecInterets
	FROM cptEpargne 
	WHERE nCompte = SELF.nCompte;
    RETURN SommeAvecInterets;
  END calculeInterets;
END;
/
show err





