----------------------------------
--manip Banque
----------------------------------

--Insertion du client
--a
INSERT INTO Client VALUES
  (client_type(99, 'Paturel', 'Port Royal  - Paris',
            telephone_vry_type(telephone_elt_vry_type('04-47-56-98-16')) ));

--b
INSERT INTO CptCourant VALUES
	(cptCourant_type('CC99', 0, SYSDATE,
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 1), 0,
	 signataire_nt_type()) 
	);

--c
UPDATE CptCourant cou
	SET   cou.ref_Client = (SELECT REF(cli) FROM Client cli WHERE cli.num = 99)
	WHERE cou.nCompte    = 'CC99';

SELECT  cou.ref_Client.num, cou.ref_Client.nom, cou.ref_Client.adresse, cou.nCompte, cou.solde
	FROM CptCourant cou ;

--d
INSERT INTO mouvement(ref_Client,ref_CptCourant,montant)
	VALUES
	((SELECT REF(cli) FROM Client cli     WHERE cli.num     = 99),
	 (SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC99'), 50 );

SELECT m.ref_Client.num, m.ref_Client.nom, m.dateOp, SYSDATE, m.montant 
	FROM Mouvement m 
	WHERE m.ref_CptCourant.nCompte = 'CC99';

--e
CREATE OR REPLACE PROCEDURE change_Portable(paramcli IN NUMBER, paramtel IN VARCHAR2) IS
   tableau_tel  telephone_vry_type;
   indice NUMBER;
BEGIN
	SELECT telephone_vry  INTO tableau_tel
		FROM Client WHERE num = paramcli  FOR UPDATE;
	IF NOT tableau_tel.EXISTS(3) THEN
		indice := 1;
		WHILE (indice  <= tableau_tel.LIMIT) LOOP
		IF NOT (tableau_tel.EXISTS(indice)) THEN
			tableau_tel.EXTEND;
			tableau_tel(indice) := telephone_elt_vry_type(NULL);
   	    		DBMS_OUTPUT.PUT_LINE('Extend ' ||indice);
		END IF;
		indice  := indice  + 1;
	END LOOP;
	END IF;
	DBMS_OUTPUT.PUT_LINE('tableau_tel(3).numTel' || tableau_tel(3).numTel);
	tableau_tel(3).numTel := paramtel;
	UPDATE Client SET  telephone_vry = tableau_tel WHERE num = paramcli;
	COMMIT;
	EXCEPTION
	 WHEN NO_DATA_FOUND THEN
    		DBMS_OUTPUT.PUT_LINE('Client inexistant');	 
END;
/
show err


SELECT * FROM Client WHERE num = 99;


EXECUTE change_Portable(99,'06-07-08-09-10');


SELECT * FROM Client WHERE num = 99;

--f

CREATE OR REPLACE PROCEDURE drop_Client(paramcli IN NUMBER) IS
BEGIN
	DELETE FROM CptEpargne cep WHERE cep.ref_Client.num = paramcli;
	DELETE FROM Mouvement mou 
		WHERE mou.ref_CptCourant.nCompte IN 
		(SELECT nCompte FROM CptCourant cou 
		 WHERE cou.ref_Client.num = paramcli);
	DELETE FROM CptCourant cou WHERE cou.ref_Client.num = paramcli;
	DELETE FROM Client WHERE num = paramcli;
	COMMIT;	 
END;
/
show err


SELECT * FROM Client WHERE num = 99;
SELECT nCompte FROM CptCourant cou WHERE cou.ref_Client.num = 99;
SELECT nCompte FROM CptEpargne cep WHERE cep.ref_Client.num = 99;
SELECT m.ref_Client.num, m.ref_Client.nom, m.ref_Cptcourant.nCompte "CPTE", 
m.dateOp, SYSDATE, m.montant 
	FROM Mouvement m 
	WHERE m.ref_CptCourant.nCompte IN (SELECT nCompte FROM CptCourant cou 
		 WHERE cou.ref_Client.num = 99);

EXECUTE  drop_Client(99);

SELECT * FROM Client WHERE num = 99;
SELECT nCompte FROM CptCourant cou WHERE cou.ref_Client.num = 99;
SELECT nCompte FROM CptEpargne cep WHERE cep.ref_Client.num = 99;
SELECT m.ref_Client.num, m.ref_Client.nom, m.ref_Cptcourant.nCompte "CPTE", 
m.dateOp, SYSDATE, m.montant 
	FROM Mouvement m 
	WHERE m.ref_CptCourant.nCompte IN (SELECT nCompte FROM CptCourant cou 
		 WHERE cou.ref_Client.num = 99);


